<template>
  <div class="app-container">
    <div style="width: 100%">
      <el-card   class="box-card"  style="height: 60px" >
        <template>
          <div class="container" type="flex" justify="center" style="text-align:center">
            <el-divider><span style="font-size:30px;color:black"><strong>活塞连杆扫码上线</strong></span></el-divider>
          </div>
        </template>
      </el-card>
<!--      <el-card class="query-card" >-->
<!--        <el-form :model="from" size="large" :inline="true" label-width="78px" @submit.native.prevent>-->
<!--          <el-form-item label-width="200" label="连杆码" :prop="from.connectCode"  style="align-content: center">-->
<!--            <input v-model="from.connectCode"-->
<!--                   ref="inputdata1"-->
<!--                   style="height: 39px; width: 300px"-->
<!--                   placeholder="请扫描连杆码"-->
<!--            />-->
<!--          </el-form-item>-->
<!--        </el-form>-->
<!--      </el-card>-->
      <!--      <el-card class="box-card" >-->
      <!--        <el-form :model="from" size="large" :inline="true" label-width="68px" @submit.native.prevent>-->
      <!--          <el-form-item label-width="200" label="活塞连杆托盘码" :prop="from.scanObject2"  style="align-content: center">-->
      <!--            <input v-model="from.scanObject2"-->
      <!--                   ref="inputdata"-->
      <!--                   style="height: 39px; width: 300px"-->
      <!--                   placeholder="请输入活塞连杆托盘码"-->
      <!--            />-->
      <!--          </el-form-item>-->
      <!--&lt;!&ndash;          <el-button type="primary" icon="el-icon-refresh" @click="handleQuery">查询</el-button>&ndash;&gt;-->
      <!--        </el-form>-->
      <!--      </el-card>-->
      <el-col :span="24" >
        <el-card class="bottom-card">
          <div slot="header" class="clearfix">
            <i class="el-icon-tickets"></i>
            <span style="font-weight: bold">当前产品信息</span>
          </div>
          <el-descriptions :column="1"  :label-style="{'font-size': '20px'}" border  :content-style="{'min-width': '300px'}">
            <el-descriptions-item label="机型">
              <span>{{queryParams.productSeries}}</span>
            </el-descriptions-item>
            <el-descriptions-item label="箱体对应SN码">
              <span>{{queryParams.scanObject1}}</span>
            </el-descriptions-item>
            <el-descriptions-item label="曲轴对应SN码">
              <span>{{queryParams.scanObject2}}</span>
            </el-descriptions-item>
            <el-descriptions-item label="结果">
              <span  style="color: #FFFFFF;"  :style="{ backgroundColor: queryParams.tileColor }">{{queryParams.words}}</span>
            </el-descriptions-item>
          </el-descriptions>
          <el-divider></el-divider>
        </el-card>
      </el-col>
    </div>
  </div>
</template>
<script>
import VueQr from 'vue-qr'
import { listTileMatchRules, getTileMatchRules, delTileMatchRules, addTileMatchRules, updateTileMatchRules } from "@/api/main/bs/tileMatchRules/tileMatchRules";
import {listStationConf,getIp} from "@/api/main/sc/stationConf";
import {setBarcodeup, outSign, getDetailData} from "@/api/main/da/tileMatchMiddleware/tileMatchMiddleware";
import {getUrl} from "@/api/main/bs/orderScheduling/orderScheduling";
import WebSocketReconnect from "@/utils/WebsocketTool";
import result from "../../../../components/Crontab/result.vue";
import {getSfcCodeByConnectCode} from "../../../../api/main/da/tileMatchMiddleware/tileMatchMiddleware";
export default {
  name: "index",
  dicts: ['colour_hex','productseries','axisname','neckname','tilename'],
  components: {
    VueQr,
  },
  data(){
    return{
      scannerFlag: false,
      loading: true,
      locationCode: "未配置",
      locationName: "未配置工位",
      tileMatchKbList: [],
      qrCode: '',
      // 查询参数
      from:{
        connectCode:'',
        pageNum: 1,
        pageSize: 10,
        productSeries: null,
        scanObject1: null,
        //scanObject1: 'P0SQ0-01FZ01-1000;T231224116;DBBBBA',
        scanObject2: null,
        axisName: null,
        neckName: null,
        tileName: null,
        axisParameterNoPosition: null,
        neckParameterPosition: null,
        axisValue: null,
        neckValue: null,
        tileColor: null,
        createUser: null,
        updateUser: null,
        state: null,
        weight: null,
      },
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        productSeries: null,
        scanObject1: null,
        // scanObject1: 'P0SQ0-01FZ01-1000;T231224116;DBBBBA',
        scanObject2: null,
        axisName: null,
        neckName: null,
        tileName: null,
        axisParameterNoPosition: null,
        neckParameterPosition: null,
        axisValue: null,
        neckValue: null,
        words:"",
        tileColor: null,
        createUser: null,
        updateUser: null,
        state: null,
        weight: null,
      },
    }
  },
  mounted() {
    // this.setFocus1()
    // this.$refs.inputdata1.addEventListener('keydown',this.handleScannerInput1)
    this.getStationConf()
    this.getWebUrl()
    this.getDetailMessage()
  },
  // beforeDestroy() {
  //   this.$refs.inputdata1.removeEventListener('keydown',this.handleScannerInput1)
  // },
  methods:{
    // setFocus1(){
    //   this.$nextTick(()=>{
    //     this.$refs.inputdata1.focus()
    //   })
    // },
    // handleScannerInput1(event) {
    //   if (this.scannerFlag) {
    //     this.$refs.inputdata1.value = ''
    //     this.scannerFlag = false
    //   }
    //   const input = event.target
    //   const inputValue = input.value
    //   this.from.connectCode = inputValue
    //   if (event.key === 'Enter') {
    //     this.scannerFlag = true
    //     //扫描完成
    //     console.log('sssss', this.from.connectCode)
    //     getSfcCodeByConnectCode({connectCode:this.from.connectCode}).then(res => {
    //       console.log('res',res)
    //       if (res.code === 200){
    //         this.queryParams.scanObject2 = res.data.sfcCode
    //
    //         if (this.queryParams.scanObject1 !== null && this.queryParams.scanObject1 !== ''
    //           && this.queryParams.scanObject2 !== null && this.queryParams.scanObject2 !== ''){
    //           if (this.queryParams.scanObject1 === this.queryParams.scanObject2){
    //             this.queryParams.words = "配对成功"
    //             this.queryParams.tileColor = "#3dcc1d"
    //             //请求出站
    //             // this.passStation()
    //           }else {
    //             this.queryParams.words = "配对失败"
    //             this.queryParams.tileColor = "#f50909"
    //           }
    //         }
    //         this.$message({
    //           message: '查询成功',
    //           type: 'success'
    //         });
    //       } else {
    //         this.$message({
    //           message: '查询失败',
    //           type: 'error'
    //         });
    //       }
    //     })
    //   }
    // },
    getWebUrl(){
      getUrl().then(res=>{
        this.websocketUrl = res+"OP050"
        console.log('websocketUrl：',this.websocketUrl)
        this.initWebSocket()
      })
    },
    initWebSocket: function (){
      //判断当前浏览器是否支持WebSocket
      if ('WebSocket' in window) {
        //连接WebSocket节点
        this.websocket = new WebSocketReconnect(this.websocketUrl);
        //接收到消息的回调方法
        this.websocket.socket.onmessage = (event) => {
          let data = event.data;
          if (data != null && data !== ''){
            this.result = JSON.parse(data);
            const resultMessage = this.result.server_message.split("*");
            console.log('resultMessage',resultMessage)
            if (resultMessage.length >=2){
              if (resultMessage[1] === "sfcCode"){
                this.queryParams.scanObject1 = resultMessage[0]
                this.queryParams.productSeries = resultMessage[2]
                this.queryParams.scanObject2 = resultMessage[3]
              } else if (resultMessage[1] === "rodCode"){
                this.queryParams.scanObject2 = resultMessage[0]
                this.queryParams.productSeries = resultMessage[2]
              } else if (resultMessage[1] === "clean"){
                this.queryParams.productSeries = ''
                this.queryParams.scanObject1 = ""
                this.queryParams.scanObject2 = ""
                this.queryParams.words = ""
                this.queryParams.tileColor = ""
              }
            }
            if (this.queryParams.scanObject1 !== null && this.queryParams.scanObject1 !== ''
              && this.queryParams.scanObject2 !== null && this.queryParams.scanObject2 !== ''){
              if (this.queryParams.scanObject1 === this.queryParams.scanObject2){
                this.queryParams.words = "配对成功"
                this.queryParams.tileColor = "#3dcc1d"
                //请求出站
                // this.passStation()
              }else {
                this.queryParams.words = "配对失败"
                this.queryParams.tileColor = "#f50909"
              }
            }


            // const parts3 = this.result.server_message.split("*");
            // if (parts3.length >= 2) {
            //   this.from.scanObject2=parts3[0];
            //   this.queryParams.words=parts3[1];
            //   this.queryParams.tileColor= parts3[2];
            //   this.handleQuery();
            // }
          }
        }
        //监听窗口关闭事件，当窗口关闭时，主动去关闭websocket连接，防止连接还没断开就关闭窗口，server端会抛异常。
        window.onbeforeunload = function () {
          this.websocket.close()
        }
        //关闭连接
        function closeWebSocket() {
          this.websocket.close()
        }
        //发送消息
        function send() {
          this.websocket.socket.send({ kk: 123 })
        }
      } else {
        alert('浏览器不支持webSocket')
      }
    },
    //刷新获取信息
    getDetailMessage(){
      getDetailData().then(res => {
        if (res.data == 200){
          console.log('res200',res)
          this.queryParams.scanObject1 = res.SfcCode
          this.queryParams.productSeries = res.productSeries
        }
      })
    },
    /** 查询工位终端配置列表 */
    getStationConf() {
      getIp().then(response => {
        let queryParams = {
          ipAddress: response.msg,
        }
        listStationConf(queryParams).then(response => {
          this.locationName = response.rows[0].processesName
          this.locationCode = response.rows[0].processesCode
        });
      });
    },
    passStation(){
      outSign().then(res =>{
        console.log("res",res)
        if (res.code === 200){
          console.log('1212121')
          this.$message({
            message: '匹配成功，已过站',
            type: 'success',
            duration:3000
          });
          this.queryParams.productSeries = ''
          this.queryParams.scanObject1 = ''
          this.queryParams.scanObject2 = ''
          this.queryParams.words = ''
          this.queryParams.tileColor = ''

        }
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.clear();
      if(this.from.scanObject2 !== null)
      {
        this.insetFromToQueryParams();
        //this.getList();
      } else{
        const h = this.$createElement;
        this.$message({
          message: h('p',null, [
            h('span', null, '警告 '),
            h('i', { style: 'color: black' }, '请填写所有搜索条件'),
            h()]),
          type: 'error',
          center: true,
          offset:300
        });
      }
    },
    cleanForm(){
      this.queryParams.productSeries = ""
      this.queryParams.scanObject1 = ""
      this.queryParams.scanObject2 = ""
      this.queryParams.words = ""
      this.queryParams.tileColor = ""
    },
    //取配瓦颜色
    getList() {
      let queryParams = {
        productSeries : this.queryParams.productSeries,
        axisName : this.queryParams.axisName,
        neckName : this.queryParams.neckName,
        tileName : this.queryParams.tileName,
        axisValue: this.queryParams.axisValue,
        neckValue: this.queryParams.neckValue,
      }
      console.log(queryParams)
      listTileMatchRules(queryParams).then(response => {
        this.queryParams.tileColor = response.rows[0].tileColor;
      });
    },
    clear(){
      this.queryParams.axisValue=null;
      this.queryParams.neckValue=null;
    },
    insetFromToQueryParams(){
      this.queryParams.productSeries=this.from.productSeries;
      this.queryParams.tileName=this.from.tileName;
      this.queryParams.scanObject2=this.from.scanObject2;
    }

  },
}
</script>

<style scoped>
::v-deep .el-form-item__label{
  font-size: large;
}
::v-deep .el-card__body{
  padding: 15px 20px 0px 20px;
}
::v-deep .el-input .el-input--medium .el-input--suffix{
  width: 200px;
}
.boxSize{
  height: 60px;
}
.centerText{
  color: black;
  font-weight: bold;
  font-size: 20px;
  display: flex;
  justify-content: center;
  margin-top: 5px
}
</style>
